' Filename: getmeta.vbs
' 
' Author: Brian J. LaSitis
' 
' Date: June 24, 2001
'
' Accompanies: QSearch 2.1
' 
' Based on a Unix shell script, getmeta, included with QSearch by Br. David Carlson, this script
' extracts the CONTENT fields of the meta KEYWORDS and DESCRIPTION HTML tags from the webroot
' and subfolder list specified in cSubFolders and enter them into keywordlist.txt in a special format.
'
' Modifications:
'	02/04/2002 - Added support for spaces to surround the commas separating the keywords specifed in the
'	KEYWORDS META tag, by removing them using a regular expression.
'
'       06/27/2003 - Minor adjustments by Br. David Carlson - It now both produces keywordfile.txt
'       and emails the file as an attachment.
'
' Uses the following tools from the Windows 2000 Server Resource Kit.
' You must have these for getmeta.vbs to work:
'       qgrep
'       where

Option Explicit

'Constants, Declarations, and Preliminary Initializations -- set these up as needed for your system:
Const cWebRoot = "k:\wwwroot"
Const cScriptPath = "c:\scriptdir"
Const cSubFolders = "folder1,folder2"
Const cDestEmailAddress = "admin@linux.collegexyz.edu"
Const cSourceEmailAddress = "webmaster@win2k.collegexyz.edu"

Dim strWebPage, strKeys, strDescription, strKeyLine
Dim fso, tsInFile, tsOutFile, oShell, oKeyLine, oDescripLine
Dim aSubFolders, strSubFolder

Set oShell = WScript.CreateObject("WScript.Shell")
Set fso = WScript.CreateObject("Scripting.FileSystemObject")

'Obtain webroot asp/htm/html/aspx files
oShell.Run "%comspec% /c dir " & cWebRoot & "\*.asp /b > " & cScriptPath & "\filelist.txt", 0, True
oShell.Run "%comspec% /c dir " & cWebRoot & "\*.html /b >> " & cScriptPath & "\filelist.txt", 0, True
oShell.Run "%comspec% /c dir " & cWebRoot & "\*.htm /b >> " & cScriptPath & "\filelist.txt", 0, True
oShell.Run "%comspec% /c dir " & cWebRoot & "\*.aspx /b >> " & cScriptPath & "\filelist.txt", 0, True

'Obtain asp/htm/html/aspx files for other specified folders
aSubFolders = Split(cSubFolders,",")
For Each strSubFolder In aSubFolders
	oShell.Run "%comspec% /c where /r " & cWebRoot & "\" & strSubFolder & _
		" *.asp *.htm *.html *.aspx >> " & cScriptPath & "\filelist.txt", 0, True
Next

'Remove unwanted lines from filelist.txt
oShell.Run "%comspec% /c qgrep -v -y ""_vti_cnf *.htm *.html *.asp *.aspx"" " & _
	cScriptPath & "\filelist.txt > " & cScriptPath & "\filelist2.txt", 0, True
oShell.Run "%comspec% /c qgrep -v -y -e ""File Not Found"" " & cScriptPath & _
	"\filelist2.txt > " & cScriptPath & "\filelist.txt", 0, True

'Remove temporary filelist2.txt used above
fso.DeleteFile("filelist2.txt")

Set tsInFile = fso.OpenTextFile("filelist.txt")
Set tsOutFile = fso.OpenTextFile("keywordfile.txt", 2, True)

'Go through each line of filelist.txt and check the associated
'web file for the desired meta tags, if present, then extract
'CONTENTS and insert into keywordfile.txt

Do While Not tsInFile.AtEndOfStream
	strKeyLine = tsInFile.ReadLine
	If (InStr(strKeyLine, "\") = 0) Then	'Check if current file is in root folder or not
		strKeyLine = cWebRoot & "\" & strKeyLine
	End If
	Set oKeyLine = oShell.Exec("%comspec% /c qgrep -y ""<meta "" "  & _
		strKeyLine  & " | qgrep -y ""keywords""")
	strKeys = Trim(oKeyLine.StdOut.ReadLine())

	If strKeys <> "" Then
		strWebPage = Replace(Mid(strKeyLine, Len(cWebRoot) + 1), "\", "/")   'Change Windows '\' to '/'
		Set oDescripLine = oShell.Exec("%comspec% /c qgrep -y ""<meta "" "  & _
			strKeyLine  & " | qgrep -y ""description""")
		strDescription = Trim(oDescripLine.StdOut.ReadLine())
                strDescription = Mid(strDescription, InStr(1, strDescription, "<"))  ' remove leading tabs
		strDescription = Mid(strDescription, 35)
		strDescription = Mid(strDescription, 1, Len(strDescription) - 2)

                strKeys = Mid(strKeys, InStr(1, strKeys, "<"))  ' make sure leading tabs are gone
		strKeys = Mid(strKeys, 32)
		strKeys = Mid(strKeys, 1, Len(strKeys) - 2)
		strKeys = SpaceFilter(strKeys)
		strKeys = "#" & Replace(strKeys, ",", "#") & "#" 'Replace ',' with '#'; add '#' to each end
		
		tsOutFile.Write(strWebPage & "|" & strDescription & strKeys & vbLf)
		Set oDescripLine = Nothing
	End If
	Set oKeyLine = Nothing
Loop

tsInFile.Close
tsOutFile.Close

' Email keywordfile.txt as an attachment:
Dim objCDONTSNewMail
Set objCDONTSNewMail = WScript.CreateObject("CDONTS.NewMail")
objCDONTSNewMail.MailFormat = 0                ' this gives CdoMailFormatMime
objCDONTSNewMail.To = cDestEmailAddress
objCDONTSNewMail.From = cSourceEmailAddress
objCDONTSNewMail.Subject = "keywordfile.txt from Windows server"
objCDONTSNewMail.Body = "Attached is the new keywordfile.txt from the Windows server" & vbLf
objCDONTSNewMail.AttachFile(cScriptPath & "\keywordfile.txt")
objCDONTSNewMail.Send()
Set objCDONTSNewMail = Nothing	

'Final housekeeping - uncomment the following 2 lines should you want to delete these files:
'fso.DeleteFile("keywordfile.txt")
'fso.DeleteFile("filelist.txt")
Set tsInFile = Nothing
Set tsOutFile = Nothing
Set fso = Nothing
Set oShell = Nothing

WScript.Quit

Function SpaceFilter(str)
	Dim objRegExp
	Set objRegExp = New RegExp
	objRegExp.Pattern = "\s*,\s*"
	objRegExp.Global = True
	SpaceFilter = objRegExp.Replace(str, ",")
	Set objRegExp = Nothing
End Function

